From 5e14b10b0ca9d34d403249d698dbefbb529f54da Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 26 2021 04:17:10 +0000
Subject: [PATCH 2191/2232] Move cxx header search to method of Includes


---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index 60bbf43..adcd048 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -48,11 +48,6 @@ pub(super) fn write(out: &mut OutFile) {
     let builtin = &mut out.builtin;
     let out = &mut builtin.content;
 
-    let cxx_header = include
-        .custom
-        .iter()
-        .any(|header| header.path == "rust/cxx.h" || header.path == "rust\\cxx.h");
-
     if builtin.rust_string {
         include.array = true;
         include.cstdint = true;
@@ -132,6 +127,7 @@ pub(super) fn write(out: &mut OutFile) {
     out.begin_block(Block::Namespace("rust"));
     out.begin_block(Block::InlineNamespace("cxxbridge1"));
 
+    let cxx_header = include.has_cxx_header();
     if !cxx_header {
         writeln!(out, "// #include \"rust/cxx.h\"");
 
diff --git a/gen/src/include.rs b/gen/src/include.rs
index 93ce60b..029b08d 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -50,6 +50,12 @@ impl<'a> Includes<'a> {
     pub fn insert(&mut self, include: impl Into<Include>) {
         self.custom.push(include.into());
     }
+
+    pub fn has_cxx_header(&self) -> bool {
+        self.custom
+            .iter()
+            .any(|header| header.path == "rust/cxx.h" || header.path == "rust\\cxx.h")
+    }
 }
 
 pub(super) fn write(out: &mut OutFile) {

